[tox]
skipdist = True
envlist = py3-{pre-commit,functional}
skip_missing_interpreters = True
isolated_build = True

# Use tox defaults when creating the source distribution and installing the
# build system requirements (poetry-core).
[testenv:.package]
install_command =

[testenv]
# skip_install = true prevents Tox from creating an sdist package and using pip to install it in the venv.
# Thus, all dependencies are installed and resolved by poetry.
basepython = python3.9 # should match the version used in CI
skip_install = true
commands_pre = poetry install
setenv =
    TERM=xterm-256color
    # sometimes poetry will fail if the keyring is not loaded on linux systems, this prevents that
    PYTHON_KEYRING_BACKEND=keyring.backends.null.Keyring

description =
    unit: Run tests
    pre-commit: Run all pre-commit checks (linters, formatters, type checkers)
    py3: (Python 3)
envdir =
    {toxworkdir}/py3-tests
commands =
    pre-commit: pre-commit run --all-files {posargs}
    functional: bats_core_pkg -T tests/functional {posargs}
allowlist_externals = poetry

[flake8]
max-line-length = 120
statistics = True
import-order-style = edited
# allow long test names and long strings
extend-ignore =
    # line breaks before binary operators
    W503
    # whitespace before :
    E203
per-file-ignores =
    tests/*.py: E501
    .pybuild/*: E501
    debian/*: E501

[testenv:py3-pre-commit]
deps =
    pre-commit>=4.0.0
commands =
    pre-commit run --all-files {posargs}

[testenv:py3-functional]
commands =
    bats_core_pkg -T tests/functional {posargs}
